//-------------------------------------------------------------------------------------------------+
// GoalPoseSender.h
// Send goal pose datas to port
//-------------------------------------------------------------------------------------------------+

#ifndef GoalPoseSender_H
#define GoalPoseSender_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service Consumer stub headers
#include "IIS2Stub.h"

using namespace RTC;
using namespace IIS;


//-------------------------------------------------------------------------------------------------+
// GoalPoseSender
//-------------------------------------------------------------------------------------------------+
class GoalPoseSender : public RTC::DataFlowComponentBase{
public:
	GoalPoseSender(RTC::Manager* manager);
	~GoalPoseSender();
	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:
	double m_goal_x;
	double m_goal_y;
	double m_goal_heading;
	int m_continuous_output;
	int m_deactivate_to_stop;

	IIS::TimedPose2DSeq m_goal_pose;
	OutPort<IIS::TimedPose2DSeq> m_goal_poseOut;
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void GoalPoseSenderInit(RTC::Manager* manager);
};

#endif // GoalPoseSender_H
